/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Fabian 'x3n' Landau
 *   Co-authors:
 *      Dominik Solenicki
 *
 */

#include "FleetController.h"


namespace orxonox
{

    RegisterClass(FleetController);

    FleetController::FleetController(Context* context) : Controller(context)
    {
        RegisterObject(FleetController);
        
        this->gameGoal_ = DOMINATE;
        this->goalPosition_ = NULL;
      /*  this->goalTarget_ = NULL;
        this->goalProtect_ = NULL;*/
        
        this->actionTimer_.setTimer(ACTION_INTERVAL, true, createExecutor(createFunctor(&FleetController::action, this)));
    }

    FleetController::~FleetController()
    {
        if (this->isInitialized())
        {
           
        }
    }
    void FleetController::action()
    {
        this->divisions_.clear();
        
        for (ObjectList<DivisionController>::iterator it = ObjectList<DivisionController>::begin(); it; ++it)
        {
            if ((this->getControllableEntity()->getTeam() == (it)->getControllableEntity()->getTeam()))
            {
                this->divisions_.push_back(*(it));
            } 
        }
        /*for(std::vector<WeakPtr<DivisionController> >::iterator it2 = divisions_.begin(); it2 != divisions_.end(); ++it2) 
        {
            (*it2)->setTargetPosition(this->getControllableEntity()->getWorldPosition());   
        }*/ 
        /*for (ObjectList<Controller>::iterator it = ObjectList<Controller>::begin(); it; ++it)
        {
            if ((this->getControllableEntity()->getTeam() != (it)->getControllableEntity()->getTeam()) && (it)->getControllableEntity()->getTeam() == 0)
            {
                for(std::vector<WeakPtr<DivisionController> >::iterator it2 = divisions_.begin(); it2 != divisions_.end(); ++it2) {
                    (*it2)->setTarget(it->getControllableEntity());   
                    (*it2)->setTargetPosition(it->getControllableEntity()->getWorldPosition());
                }               
                break;
            } 
        }*/

    }
    void FleetController::tick(float dt)
    {

        SUPER(FleetController, tick, dt);

    }
    void FleetController::XMLPort(Element& xmlelement, XMLPort::Mode mode)
    {
        SUPER(FleetController, XMLPort, xmlelement, mode);

        //XMLPortObject(FleetController, GameGoal, "gameGoal", setGameGoal, getGameGoal, xmlelement, mode).defaultValues(DOMINATE);
        //XMLPortParam(FleetController, "goalPosition", setGoalPosition, getGoalPosition, xmlelement, mode).defaultValues(NULL);
        //XMLPortParam(FleetController, "goalTarget", setGoalTarget, getGoalTarget, xmlelement, mode).defaultValues(NULL);
        //XMLPortParam(FleetController, "goalProtect", setGoalProtect, getGoalProtect, xmlelement, mode).defaultValues(NULL);

    }

    
   

}
